#include "BePreference.h"
#include "YaConstantes.h"

#include <FindDirectory.h>
#include <Directory.h>
#include <Path.h>
#include <Entry.h>
#include <File.h>
#include <Control.h>
#include <stdio.h>

BePreference::BePreference(const char *fileName,const char *extendedPath)
: BMessage(M_PREFERENCE_MSG)
{
	BPath		path;
	BEntry		settingPathEntry;
	
	// par defaut on a pas reussi
	_state = B_ERROR;

	// trouver si le repertoire Settings existe
	if(find_directory(B_USER_SETTINGS_DIRECTORY,&path)!=B_OK)
		path.SetTo("/boot/home/config/settings");

	// verifier si le repertoire MeTOS existe
	// sinon le creer
	_filePath = path.Path();
	_filePath << "/" << BEYAHTZE_SETTINGS_FOLDER;
	settingPathEntry.SetTo(_filePath.String());
	if(!(settingPathEntry.Exists()))
		create_directory(_filePath.String(),00777);

	// on est dans un sous repertoire
	if(extendedPath!=NULL)
	{
		BString		extendedPathString;
		
		extendedPathString = extendedPath;
		if(extendedPathString.Length()>0)
		{
			_filePath << "/";
			_filePath << extendedPath;
			settingPathEntry.SetTo(_filePath.String());
			if(!(settingPathEntry.Exists()))
				create_directory(_filePath.String(),00777);
		}
	}
	
	_filePath << "/";
	_filePath << fileName;
	_filePath << ".prefs";
	_state = B_OK;
}

/**** destructeur ****/
BePreference::~BePreference()
{		
}

// ===================================
// = Lecture et ecriture des données =
// ===================================

/**** sauvegarder les prefs ****/
status_t BePreference::Save()
{	
	BFile		file;
	MakeEmpty();
   	AddString("name0",name[0]);
   	AddString("name1",name[1]);
   	AddString("name2",name[2]);
   	AddString("name3",name[3]);
   	AddString("name4",name[4]);
   	AddString("name5",name[5]);
   	AddString("name6",name[6]);
   	AddString("name7",name[7]);
   	AddString("name8",name[8]);
   	AddString("name9",name[9]);
   	AddString("name10",name[10]);
   	AddString("name11",name[11]);
   	AddString("name12",name[12]);
   	AddString("name13",name[13]);
   	AddString("name14",name[14]);
   	AddString("name15",name[15]);
   	AddString("name16",name[16]);
   	AddString("name17",name[17]);
   	AddString("name18",name[18]);
   	AddString("name19",name[19]);
   	
   	AddInt32("score0",score[0]);
   	AddInt32("score1",score[1]);
   	AddInt32("score2",score[2]);
   	AddInt32("score3",score[3]);
   	AddInt32("score4",score[4]);
   	AddInt32("score5",score[5]);
   	AddInt32("score6",score[6]);
   	AddInt32("score7",score[7]);
   	AddInt32("score8",score[8]);
   	AddInt32("score9",score[9]);
   	AddInt32("score10",score[10]);
   	AddInt32("score11",score[11]);
   	AddInt32("score12",score[12]);
   	AddInt32("score13",score[13]);
   	AddInt32("score14",score[14]);
   	AddInt32("score15",score[15]);
   	AddInt32("score16",score[16]);
   	AddInt32("score17",score[17]);
   	AddInt32("score17",score[18]);
   	AddInt32("score17",score[19]);

	if(_state!=B_OK)
		return B_ERROR;

	if(file.SetTo(_filePath.String(),B_CREATE_FILE|B_ERASE_FILE|B_WRITE_ONLY)!=B_OK)
		return B_ERROR;
	
	// sauver si le message n'est pas etre vide
	if(IsEmpty())
		return B_ERROR;
	
	if(BMessage::Flatten(&file)!=B_OK)
		return B_ERROR;
	
	return B_OK;
}

/**** charger les prefs ****/
status_t BePreference::Load()
{
	BFile		file;

	if(_state!=B_OK)
		return B_ERROR;

	if(file.SetTo(_filePath.String(),B_READ_ONLY)!=B_OK)
	{
	    
        for (int i=0;i<20;i++)
        {
          name[i].SetTo("Baldur");
          score[i]=100;
        }
		return B_ERROR;
	}
	// charger les donnees dans le message
	BMessage::MakeEmpty();
	if(BMessage::Unflatten(&file)!=B_OK)
		return B_ERROR;
	
	
	FindString("name0",0,&name[0]);
	FindString("name1",0,&name[1]);
	FindString("name2",0,&name[2]);
	FindString("name3",0,&name[3]);
	FindString("name4",0,&name[4]);
	FindString("name5",0,&name[5]);
	FindString("name6",0,&name[6]);
	FindString("name7",0,&name[7]);
	FindString("name8",0,&name[8]);
	FindString("name9",0,&name[9]);
	FindString("name10",0,&name[10]);
	FindString("name11",0,&name[11]);
	FindString("name12",0,&name[12]);
	FindString("name13",0,&name[13]);
	FindString("name14",0,&name[14]);
	FindString("name15",0,&name[15]);
	FindString("name16",0,&name[16]);
	FindString("name17",0,&name[17]);
	FindString("name18",0,&name[18]);
	FindString("name19",0,&name[19]);

	FindInt32("score0",0,&score[0]);
	FindInt32("score1",0,&score[1]);
	FindInt32("score2",0,&score[2]);
	FindInt32("score3",0,&score[3]);
	FindInt32("score4",0,&score[4]);
	FindInt32("score5",0,&score[5]);
	FindInt32("score6",0,&score[6]);
	FindInt32("score7",0,&score[7]);
	FindInt32("score8",0,&score[8]);
	FindInt32("score9",0,&score[9]);
	FindInt32("score10",0,&score[10]);
	FindInt32("score11",0,&score[11]);
	FindInt32("score12",0,&score[12]);
	FindInt32("score13",0,&score[13]);
	FindInt32("score14",0,&score[14]);
	FindInt32("score15",0,&score[15]);
	FindInt32("score16",0,&score[16]);
	FindInt32("score17",0,&score[17]);
	FindInt32("score18",0,&score[18]);
	FindInt32("score19",0,&score[19]);
	return B_OK;
}

int	BePreference::ajoute_score(int scor, const char *nam)
{
	// retourne la position du nouveau score
	int pos=-1;
	for (int i=0;i<20;i++)
	{
	  if ((score[i]<scor)&&(pos==-1))
	  {
	  	pos=i;
	  }
	}
	// Il faut inserer le nouveau score
	if (pos != -1)
	{
	  	for (int j=19;j>pos;j--)
	  	{
	  		name[j]=name[j-1];
	  		score[j]=score[j-1];
	  	}
		name[pos].SetTo(nam);
		score[pos]=scor;	  
	}
	return pos;
}




