#define _YaAPP_CPP_

#include "YaConstantes.h"
#include "YaMainWindow.h"
#include "YaApp.h"
#include "YaAbout.h"
#include "YaHall.h"
#include "BeYamAboutWin.h"
#include "BeYamHallWin.h"
#include "BeYaminputWin.h"

#include <Alert.h>
#include <stdlib.h>
#include <time.h>
#include <limits.h>
#include <File.h>
#include <Entry.h>
#include <Node.h>
#include <NodeInfo.h>
#include <Directory.h>
#include <FindDirectory.h>
#include <Path.h>
#include <Bitmap.h>
#include <View.h>
#include <stdio.h>
#include <Roster.h>


YaApp *ya_app;

YaApp::YaApp()
:BApplication(YA_NOM_APP)
{
	ya_app = this;
	
	// initialisation
	YaMain = new YaMainWindow();
	YaMain->Show();

  	BFile file;
	app_info			info;

	GetAppInfo(&info);
	file.SetTo(&(info.ref), B_READ_ONLY);
	Yaressource.SetTo(&file);
	

	
}

YaApp::~YaApp()
{
}

void YaApp::MessageReceived(BMessage *msg)
{
	switch(msg->what)
	{
	 case QUIT_GAME : 
	 		be_app->PostMessage(B_QUIT_REQUESTED);
	 	break;
	  case MENU_ABOUT:
	    ShowAbout();
	    break;  
  	 case LANCER_FIN :
		ShowInput(0);  	 
  	    break;
  	 case OK_NAME :
  	    HallInput->Quit();
		ShowHall(total_libre);  	 
  	    break;
	  case MENU_HALL:
	    ShowHall(-1);
	    break;  
	 case NEW_GAME:
	    //YaMain->New_Game();
	    YaMain->PostMessage(NEW_YAM);
	    break;   
	default:
		BApplication::MessageReceived(msg);
	}
}


// =======================================
// = extraire des données des ressources =
// =======================================

/**** trouver une image dans les ressources ****/
BBitmap *YaApp::GetBitmap(int no)
{
	BBitmap 	*bitmap = NULL;
	size_t 		len = 0;
	status_t 	error;	

	// charger depuis les ressources
	const void *data = Yaressource.LoadResource('BBMP', no, &len);

	BMemoryIO stream(data, len);
	
	// charge l'image archivé
	BMessage archive;
	error = archive.Unflatten(&stream);
	if (error != B_OK)
		return NULL;

	// on va essayer de la recreer
	bitmap = new BBitmap(&archive);
	if(!bitmap)
		return NULL;

	// verifier que ca a marché
	if(bitmap->InitCheck() != B_OK)
	{
		delete bitmap;
		return NULL;
	}
	
	// tout c'est bien passé
	return bitmap;
}

void YaApp::ShowAbout()
{
	BeYamAboutWin				*aboutWin = NULL;

	// fenetre a propos
	aboutWin = new BeYamAboutWin(BRect(280,200,450,370));
	aboutWin->AddToSubset(YaMain);
	aboutWin->Show();

}

void YaApp::ShowHall(int score)
{
	BeYamHallWin				*HallWin = NULL;

	// fenetre a propos
	HallWin = new BeYamHallWin(BRect(280,200,500,500));
	HallWin->AddToSubset(YaMain);
	HallWin->Show();

}

void YaApp::ShowInput(int score)
{

	// fenetre a propos
	HallInput = new BeYamInputWin(BRect(280,200,500,300));
	HallInput->AddToSubset(YaMain);
	HallInput->Show();

}



