#include "YaConstantes.h"
#include "YaApp.h"
#include "YaMainWindow.h"


#include <Box.h>
#include <Button.h>
#include <CheckBox.h>
#include <String.h>
#include <Alert.h>
#include <MenuBar.h>
#include <Menu.h>
#include <MenuItem.h>
#include <StringView.h>
#include <Window.h>

#include <stdio.h>
#include <stdlib.h>
#include <time.h>
#include "YaText.h"
#include "YaDe.h"
#include "YaView.h"


YaMainWindow::YaMainWindow()
:BWindow(BRect(100,150,600,650),"BeYahtzé",B_TITLED_WINDOW,B_NOT_RESIZABLE|B_NOT_RESIZABLE|B_NOT_ZOOMABLE,B_CURRENT_WORKSPACE)
{
	BRect rect;
	BView *vue;
	
	// Set the menu bar
	BMenu			*menu = NULL;
	
	// creation de la bar de menu
	rect = Bounds();
	MenuBar = new BMenuBar(rect,"Main menu");
	

	// menu File
	menu = new BMenu("File");
	menu->AddItem(new BMenuItem("Quit",new BMessage(QUIT_GAME),'Q'));
	MenuBar->AddItem(menu);
	// definir la destination des messages du menu
	menu->SetTargetForItems(be_app);

	// Menu View
	menu = new BMenu("Game");
	menu->AddItem(new BMenuItem("New",new BMessage(NEW_GAME)));
	menu->AddSeparatorItem();
	menu->AddItem(new BMenuItem("Hall of fame",new BMessage(MENU_HALL)));
    MenuBar->AddItem(menu);
	// definir la destination des messages du menu
	menu->SetTargetForItems(be_app);

	// Menu About
	menu = new BMenu("About");
	menu->AddItem(new BMenuItem("About",new BMessage(MENU_ABOUT)));
    MenuBar->AddItem(menu);
	// definir la destination des messages du menu
	menu->SetTargetForItems(be_app);


	AddChild(MenuBar);
	
	
	// VUE
	rect = Bounds();
	vue = new BView(rect,"vue1",0,B_WILL_DRAW);
	vue->SetViewColor(216,216,216,0);
	
	// BOX de
	rect = vue->Bounds();
	rect.InsetBy(3,3);
	rect.right -= 350;
	rect.top += 20;
	box_de = new BBox(rect,"de",0,B_WILL_DRAW);
	vue->AddChild(box_de);
	
	// BOX jeux
	rect = vue->Bounds();
	rect.InsetBy(3,3);
	rect.left += 150;
	rect.top += 20;
	box_jeux = new YaView(rect,"Exposition",0,B_WILL_DRAW);
	vue->AddChild(box_jeux);
	
	
	rect = box_de->Bounds();
	rect.InsetBy(10,10);
	AddChild(vue);
	

    // Initialisation des affichages des possibiltés
    BStringView *label;
    char *p;
    int posx = 30;
    for (int i=1;i<=17;i++)
    {
      switch (i)
      {
        case 1: p="1"; break;
        case 2: p="2"; break;
        case 3: p="3"; break;
        case 4: p="4"; break;
        case 5: p="5"; break;
        case 6: p="6"; break;
        case 7: p="Total"; break;
        case 8: p="Bonus"; break;
        case 9: p="Total"; break;
        case 10: p="3 of"; break;
        case 11: p="4 of"; break;
        case 12: p="Full"; break;
        case 13: p="Small suite"; break;
        case 14: p="Big suite"; break;
        case 15: p="Yathze"; break;
        case 16: p="Chance"; break;
        case 17: p="Total"; break;
      }
	  label = new BStringView(BRect(10,posx,50,posx+10),"1",p);
	  posx=posx+20;
	  label->MakeFocus(false);
	  box_jeux->AddChild(label);
    }
    
    // Init de la colonne libre
    Libre= new YaColonne("Libre",1,box_jeux);
    
    // Init des dés et check des dés
    //de[0] = new BButton(BRect(20,20,50,50),"d1","",NULL);
    //box_de->AddChild(de[0]);
    de[0] = new YaDe(BRect(20,20,50,50));
    box_de->AddChild(de[0]);
    c[0] = new BCheckBox(BRect(60,25,80,35),"c1","",new BMessage(Check_d1));
    box_de->AddChild(c[0]);

    de[1] = new YaDe(BRect(20,70,50,100));
    box_de->AddChild(de[1]);
    c[1] = new BCheckBox(BRect(60,75,80,85),"c2","",new BMessage(Check_d2));
    box_de->AddChild(c[1]);

    de[2] = new YaDe(BRect(20,120,50,150));
    box_de->AddChild(de[2]);
    c[2] = new BCheckBox(BRect(60,125,80,135),"c3","",new BMessage(Check_d3));
    box_de->AddChild(c[2]);

    de[3] = new YaDe(BRect(20,170,50,200));
    box_de->AddChild(de[3]);
    c[3] = new BCheckBox(BRect(60,175,80,185),"c4","",new BMessage(Check_d4));
    box_de->AddChild(c[3]);

    de[4] = new YaDe(BRect(20,220,50,250));
    box_de->AddChild(de[4]);
    c[4] = new BCheckBox(BRect(60,225,80,235),"c5","",new BMessage(Check_d5));
    box_de->AddChild(c[4]);

    Lance = new BButton(BRect(10,280,100,310),"lance","launch",new BMessage(LANCER_CLICK));
    box_de->AddChild(Lance);
    
    // Init du jeux
	//PostMessage(NEW_GAME);
  	srand(time(NULL));
  	//srand(time());
	
	
}

YaMainWindow::~YaMainWindow()
{
}

void YaMainWindow::lance_de()
{
	if (Nb_Pose==13)
	{
       Lance->SetEnabled(false);
       for (int i=0;i<5;i++)
       {
        de[i]->Set_to(1);
       }
       ya_app->PostMessage(LANCER_FIN);
 	}
	else
	{
       Nb_tirage++;
       // Tirage des dés et affichage des valeurs
       for (int i=0;i<5;i++)
       {
         if (c[i]->Value()==0)
         {
            valeur_de[i]=rand()%(6) + 1;
           de[i]->Set_to(valeur_de[i]);
          }
       }
       printf("%d\n",Nb_tirage);
       if (Nb_tirage==3)
       {
         Lance->SetEnabled(false);
       }
     }  
	if (Nb_Pose==13)
	{
		Lance->SetLabel("end");
	}
}

void YaMainWindow::MessageReceived(BMessage *msg)
{
	switch(msg->what)
	{
	 case LANCER_CLICK:
	    lance_de();
	    break;   
	 case NEW_YAM:
		Libre->New();
    	// Init du jeux
    	Nb_tirage=0;
    	Nb_Pose=0;
		Lance->SetLabel("Launch");
    	Lance->SetEnabled(true);
	    lance_de();
	 	break;  
	default:		
		BWindow::MessageReceived(msg);
	}
}

// bool YaMainWindow::QuitRequested(void)
//{
//		be_app->PostMessage(B_QUIT_REQUESTED); 	 
//}

void selsort (int *a, int num_elems) 
    { 
    // selection sort 
        
    int lo = 0; 
    int hi = num_elems - 1; 
    int tmp; 
        
    for (; lo < hi; ++lo) 
        { 
        int min = lo; 
        int i   = lo+1; 
                
        for (; i <= hi; ++i) 
            if (a[i] < a[min]) 
                min = i; 
                
        tmp = a[lo], a[lo] = a[min], a[min] = tmp; 
        } 
    } 
    

int YaMainWindow::Valeur(int pos)
{
   int tot=0;
   switch (pos)
   {
     case 1 : for (int i=0;i<5;i++){if (valeur_de[i]==1) tot++;}
     break;
     case 2 : for (int i=0;i<5;i++){if (valeur_de[i]==2) tot=tot+2;}
     break;
     case 3 : for (int i=0;i<5;i++){if (valeur_de[i]==3) tot=tot+3;}
     break;
     case 4 : for (int i=0;i<5;i++){if (valeur_de[i]==4) tot=tot+4;}
     break;
     case 5 : for (int i=0;i<5;i++){if (valeur_de[i]==5) tot=tot+5;}
     break;
     case 6 : for (int i=0;i<5;i++){if (valeur_de[i]==6) tot=tot+6;}
     break;


     case 10 : // brelan : 3 identiques ( somme de tous les dé)
        {
        	int nb; 
        	int pareil=0;   
        	for (int val=1;val<6;val++)
        	{	
            	nb=0;
          		for (int i=0;i<5;i++)
          		{	
          			if (valeur_de[i]==val) nb++;
          		}
          		if (nb == 3) pareil=val;
        	}
        	if (pareil!=0)
        	{
         		for (int i=0;i<5;i++){tot=tot+valeur_de[i];}
        	}
        }
        break;
     
     case 11 : // carré : 4 identiques ( somme de tous les dé)
        {
        	int nb; 
        	int pareil=0;   
        	for (int val=1;val<6;val++)
        	{
            	nb=0;
          		for (int i=0;i<5;i++)
          		{
          			if (valeur_de[i]==val) nb++;
          		}
          		if (nb == 4) pareil=val;
        	}
        	if (pareil!=0)
        	{
         		for (int i=0;i<5;i++){tot=tot+valeur_de[i];}
        	}
        }
     break;
     
     case 12 : // full : 3+2 identiques ( somme de tous les dé)
        {
        	int nb[6]; 
        	int pareil=0;   
        	bool nb2 = false;
        	bool nb3 = false;
    		printf("%d,%d,%d,%d,%d\n",valeur_de[0],valeur_de[1],valeur_de[2],valeur_de[3],valeur_de[4]);
        	for (int val=1;val<6;val++)
        	{
            	nb[val]=0;
          		for (int i=0;i<5;i++)
          		{
          			if (valeur_de[i]==val) nb[val]++;
          		}
          		if ((nb[val] == 3) && (nb3 == false))
          		{
          		 	pareil++;
          		 	nb3=true;
          		}
          		if ((nb[val] == 2) && (nb2 == false))
          		{
          			pareil++;
          			nb2=true;
          		}	
        	}
        	if (pareil==2)
        	{
         		for (int i=0;i<5;i++){tot=tot+valeur_de[i];}
        	}
        }	
     break;
     
     case 13 : // Pte suite - 20
     	{
     	 	// on fait une copie des de
     	 	int copie[5];
    		for (int i=0;i<5;i++){copie[i]=valeur_de[i];}
    		printf("%d,%d,%d,%d,%d\n",copie[0],copie[1],copie[2],copie[3],copie[4]);
    		// on enlève celui qui doit etre present 2 fois
    		int nb[7];
    		for (int i=0;i<7;i++)
    		{
    			nb[i]=0;
    		}
    		for (int i=0;i<5;i++)
    		{
    			nb[copie[i]]++;
    			if (nb[copie[i]]==2)
    			{
    				printf("enlève %d\n",i);
    				copie[i]=0;
    			}
    		}
    		
    		printf("%d,%d,%d,%d,%d\n",copie[0],copie[1],copie[2],copie[3],copie[4]);
    		selsort (copie, 5);
    		printf("%d,%d,%d,%d,%d\n",copie[0],copie[1],copie[2],copie[3],copie[4]);
	 		if (
	 		    ((copie[0]==1)&&(copie[1]==2)&&(copie[2]==3)&&(copie[3]==4))||		    
	 		    ((copie[0]==2)&&(copie[1]==3)&&(copie[2]==4)&&(copie[3]==5))||
	 		    ((copie[0]==3)&&(copie[1]==4)&&(copie[2]==5)&&(copie[3]==6))||

	 		    ((copie[1]==1)&&(copie[2]==2)&&(copie[3]==3)&&(copie[4]==4))||		    
	 		    ((copie[1]==2)&&(copie[2]==3)&&(copie[3]==4)&&(copie[4]==5))||
	 		    ((copie[1]==3)&&(copie[2]==4)&&(copie[3]==5)&&(copie[4]==6))
	 		    )
	 		    {
	 		    	tot=20;
	 		    }
 			    	
     	}
     	break;

     case 14 : // gDe suite - 40
     	{
     	 	// on fait une copie des de
     	 	int copie[5];
    		for (int i=0;i<5;i++){copie[i]=valeur_de[i];}
    		selsort (copie, 5);
	 		if (((copie[0]==1)&&(copie[1]==2)&&(copie[2]==3)&&(copie[3]==4)&&(copie[4]==5))||		    
	 		    ((copie[0]==2)&&(copie[1]==3)&&(copie[2]==4)&&(copie[3]==5)&&(copie[4]==6)))
	 		    {
	 		    	tot=40;
	 		    }
     	}
     	break;
     case 15 : // Yam : 5 identiques ( 60)
        {
 			if ((valeur_de[0]==valeur_de[1])&&(valeur_de[1]==valeur_de[2])       
 			    &&(valeur_de[2]==valeur_de[3])&&(valeur_de[3]==valeur_de[4]))
        	{
        	 	tot=60;
         	}
        }
     break;
     case 16 : // chance somme
        {
      		for (int i=0;i<5;i++){tot=tot+valeur_de[i];}
        }
     break;
     	
   }
   return tot;
}






